-- everything rival related
tsrb2kr.Framework_HandleRivals = function(p)
	local mo = p.mo
	if not (mo and mo.valid) then return end
		
	-- to avoid desynch, always spawn the rival thing ontop of EACH player
	if not mo.tsr_rivalmark or not mo.tsr_rivalmark.valid
		mo.tsr_rivalmark = P_SpawnMobj(mo.x, mo.y, mo.z, MT_TSR_RIVAL)
		mo.tsr_rivalmark.target = mo
		mo.tsr_rivalmark.flags2 = MF2_DONTDRAW
	end
end

tsrb2kr.Rivals_Takedown = function(p, inflictor, source)
	if not (G_RaceGametype()) then return end
	
    -- we were spun out etc etc, check if the opponent was of a rival team below us, if yes, give em ultcharge
    local p2
    if ((inflictor and inflictor.valid) and inflictor.player)
        p2 = inflictor.player
    end
    if ((source and source.valid) and source.player)
        p2 = source.player
    end
    if not (p2 and p2.valid) then return end

	if tsrb2kr.IsRival(p2, p)
        -- yep. Give ult charge to p2.
        tsrb2kr.FillUltimate(p2, 160, "TAKEDOWN!", {tsrb2kr.ColorToMap(tsrb2kr.ReturnTeamColor(p.tsr.team), true)}, sfx_ncitem)
    end
end
addHook("PlayerSpin", tsrb2kr.Rivals_Takedown)
addHook("PlayerSquish", tsrb2kr.Rivals_Takedown)
addHook("PlayerExplode", tsrb2kr.Rivals_Takedown)